#!/usr/bin/perl
# Programmi kasutamiseks tuleb määrata kas kasutada UTF-8 kodeeringus treeningfaile,
# milleks on lipp -utf8.
# Faili mille keelt tuvastada saab määrata -fail <faili nimi>
use Encode qw(encode decode);
use Lingua::Ident;
use Getopt::Long;
binmode (STDOUT, ":utf8");
my $utf8, $lauseid=0;
$result = GetOptions ( "utf8"  => \$utf8);

#Milliseid treeningfaile tuvastamisel kasutada -utf8 lipuga kasutab UTF-8 kodeeringus treeningfaile		
if($utf8){
	use Ident_muudetud '.';
	$classifier = new Ident_muudetud("eesti_utf.trainlid", "saksa_utf.trainlid", "inglise_utf.trainlid");
}
else{
	$classifier = new Lingua::Ident("eesti.trainlid", "inglise.trainlid", "saksa.trainlid");
}
while ( $content = <STDIN>)
{
chomp($content);
$content=decode('UTF-8', $content);
# eemalda ebavajalik
$content=~ s/@/\&uusatmargend;/g;
$content=~ s/<ignoreeri>/<@>/g;
$content=~ s/<\/ignoreeri>/<\/@>/g;
$content=~ s/<@>[^@]*<\/@>//g;
$content=~ s/&uusatmargend;/@/g;
$content=~ s/<[^<>]*>//g;
$content=~ s/&amp;/ /g;
$content=~ s/&lt;/ /g;
$content=~ s/&gt;/ /g;
$content=~ s/[^[:alpha:] ]//g;
$content=~ tr/ / /s;
$content=~ s/^ //;
$content=~ s/ $//;
#väiketähtedeks
$content = lc $content;	
$pikkus = length($content);
$keel="eesti";

if($pikkus!=0){
	$hinnang = $classifier->calculate($content);
	$keel=$$hinnang[0][0];
	$lauseid=$lauseid+1;
	# kui ükski mudel ei taha sobida, siis arvatavasti ongi mingi tundmatu keel
	if ( ($keel eq "eesti") && (($$hinnang[0][1])/$pikkus < -2.9) )
		{
		$keel = "tundmatu";
		}
	if ($$hinnang[0][1] != 0 && $keel ne "eesti")
		{
		# kui vaja keel täpsemalt märkida siis
                # print "<foreign keel='",$keel,"'>", $content, "</foreign>\n";
		print "<foreign keel='","mitte_eesti","'>", $content, "</foreign>\n";
		}
	# eesti keel, foreign märgendit pole vaja panna
	else
	{
		print $content, "\n";

	}
}
}
print STDERR "Lauseid oli failis ",$lauseid,"\n";

#print "Teksti keel on tuvastatud kui '",$$hinnang[0][0],"' \n";
#print "Keele '",$$hinnang[0][0],"' hinnang ",$$hinnang[0][1]," \n";
#print "Teisena tuvastatud keele '",$$hinnang[1][0],"' hinnang ",$$hinnang[1][1],"\n";
#print "Kolmandana tuvastatud keele '",$$hinnang[2][0],"' hinnang ",$$hinnang[2][1],"\n";
#print "Esimese ja teise keele hinnangu vahe (hinnangukindlus)= ",abs($$hinnang[0][1]-$$hinnang[1][1]),"\n";

